import { useCallback, useEffect, useRef } from 'react';
import { useActionHandler } from '../../actions/useActionHandler';
import { useProductStore } from '../../../../store/simulation/useProductStore';
import { useSelectedProduct } from '../../../../store/simulation/useSimulationStore';
import { useMaterialStore } from '../../../../store/simulation/useMaterialStore';

export function useTriggerHandler() {
    const { getActionByUuid, getEventByTriggerUuid, getEventByModelUuid } = useProductStore();
    const { handleAction } = useActionHandler();
    const { getMaterialByCurrentModelUuid, setCurrentLocation, setNextLocation } = useMaterialStore();
    const { selectedProduct } = useSelectedProduct();

    const handleTrigger = (trigger: TriggerSchema, actionUuid: string) => {

        // const fromEvent = getEventByTriggerUuid(selectedProduct.productId, trigger.triggerUuid);
        // console.log('fromEvent: ', fromEvent);

        // const toEvent = getEventByModelUuid(selectedProduct.productId, trigger.triggeredAsset?.triggeredModel.modelUuid || '');
        // console.log('toEvent: ', toEvent);

        // if (fromEvent?.type === 'transfer') {
        //     if (toEvent?.type === 'transfer') {
        //         // console.log('toEvent: ', toEvent.type);
        //         // Transfer to Transfer
        //         const action = getActionByUuid(selectedProduct.productId, trigger.triggeredAsset?.triggeredAction?.actionUuid || '');
        //         if (action && trigger.triggeredAsset && trigger.triggeredAsset.triggeredPoint && trigger.triggeredAsset.triggeredAction) {
        //             const material = getMaterialByCurrentModelUuid(fromEvent.modelUuid);
        //             if (material) {
        //                 if (material.next &&
        //                     action.triggers[0].triggeredAsset?.triggeredAction?.actionUuid &&
        //                     action.triggers[0].triggeredAsset?.triggeredPoint?.pointUuid) {

        //                     setCurrentLocation(material.materialId, material.next);

        //                     setNextLocation(material.materialId, {
        //                         modelUuid: toEvent.modelUuid,
        //                         pointUuid: action.triggers[0].triggeredAsset?.triggeredPoint?.pointUuid,
        //                         actionUuid: action.triggers[0].triggeredAsset?.triggeredAction?.actionUuid
        //                     });
        //                 }
        //                 handleAction(action);
        //             }
        //         }
        //     } else if (toEvent?.type === 'vehicle') {
        //         // Transfer to Vehicle

        //     } else if (toEvent?.type === 'machine') {
        //         // Transfer to Machine

        //     } else if (toEvent?.type === 'roboticArm') {
        //         // Transfer to Robotic Arm

        //     } else if (toEvent?.type === 'storageUnit') {
        //         // Transfer to Storage Unit

        //     }
        // } else if (fromEvent?.type === 'vehicle') {
        //     if (toEvent?.type === 'transfer') {
        //         // Vehicle to Transfer

        //     } else if (toEvent?.type === 'vehicle') {
        //         // Vehicle to Vehicle

        //     } else if (toEvent?.type === 'machine') {
        //         // Vehicle to Machine

        //     } else if (toEvent?.type === 'roboticArm') {
        //         // Vehicle to Robotic Arm

        //     } else if (toEvent?.type === 'storageUnit') {
        //         // Vehicle to Storage Unit

        //     }
        // } else if (fromEvent?.type === 'machine') {
        //     if (toEvent?.type === 'transfer') {
        //         // Machine to Transfer

        //     } else if (toEvent?.type === 'vehicle') {
        //         // Machine to Vehicle

        //     } else if (toEvent?.type === 'machine') {
        //         // Machine to Machine

        //     } else if (toEvent?.type === 'roboticArm') {
        //         // Machine to Robotic Arm

        //     } else if (toEvent?.type === 'storageUnit') {
        //         // Machine to Storage Unit

        //     }
        // } else if (fromEvent?.type === 'roboticArm') {
        //     if (toEvent?.type === 'transfer') {
        //         // Robotic Arm to Transfer

        //     } else if (toEvent?.type === 'vehicle') {
        //         // Robotic Arm to Vehicle

        //     } else if (toEvent?.type === 'machine') {
        //         // Robotic Arm to Machine

        //     } else if (toEvent?.type === 'roboticArm') {
        //         // Robotic Arm to Robotic Arm

        //     } else if (toEvent?.type === 'storageUnit') {
        //         // Robotic Arm to Storage Unit

        //     }
        // } else if (fromEvent?.type === 'storageUnit') {
        //     if (toEvent?.type === 'transfer') {
        //         // Storage Unit to Transfer

        //     } else if (toEvent?.type === 'vehicle') {
        //         // Storage Unit to Vehicle

        //     } else if (toEvent?.type === 'machine') {
        //         // Storage Unit to Machine

        //     } else if (toEvent?.type === 'roboticArm') {
        //         // Storage Unit to Robotic Arm

        //     } else if (toEvent?.type === 'storageUnit') {
        //         // Storage Unit to Storage Unit

        //     }
        // }
    }

    const triggerPointActions = useCallback((action: Action) => {
        if (!action) return;

        action.triggers.forEach(trigger => {
            switch (trigger.triggerType) {
                case 'onStart':
                    break;
                case 'onComplete':
                    handleTrigger(trigger, action.actionUuid);
                    break;
                case 'onStop':
                    break;
                case 'onError':
                    break;
                case 'delay':
                    break;
                default:
                    console.warn(`Unknown trigger type: ${trigger.triggerType}`);
            }
        });
    }, []);

    return {
        triggerPointActions
    };
}